/** 
 *  Hyper Operating System  Application Framework
 *
 * @file  type.h
 * @brief %jp{{^`}
 *
 * Copyright (C) 2006-2008 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#ifndef __HOS__type_h__
#define __HOS__type_h__

	
/* ---------------------------------- */
/*             {                 */
/* ---------------------------------- */

/* {^ */
typedef	signed char			_HOS_SINT8;
typedef	unsigned char		_HOS_UINT8;
typedef	signed short		_HOS_SINT16;
typedef	unsigned short		_HOS_UINT16;
typedef	signed long			_HOS_SINT32;
typedef	unsigned long		_HOS_UINT32;

/* 64bit^ */
#if defined(_HOS_LONGLONG) || defined(__GNUC__) || defined(__ARMCC_VERSION)
#define _HOS_ENABLE64
typedef	signed long long	_HOS_SINT64;
typedef	unsigned long long	_HOS_UINT64;
#elif defined(_MSC_VER)
#define _HOS_ENABLE64
typedef	signed __int64		_HOS_SINT64;
typedef	unsigned __int64	_HOS_UINT64;
#else
typedef	signed long			_HOS_SINT64;
typedef	unsigned long		_HOS_UINT64;
#endif


/* NULL */
#ifndef NULL
#ifdef __cplusplus
#define NULL				(0)
#else
#define NULL				((void *)0)
#endif
#endif



/* ---------------------------------- */
/*            ˕                */
/* ---------------------------------- */

#define MEMALIGN			sizeof(void *)		/* ACg` */

typedef long				VPARAM;				/* Cӂ̃p[^^ */
typedef unsigned long		MEMSIZE;			/* TCY̌^ */
typedef unsigned long		FILESIZE;			/* t@CTCY̌^ */
typedef unsigned long		TIME;				/* Ԃ̌^ */



/* ---------------------------------- */
/*            ˕                */
/* ---------------------------------- */

/* nh̒` */
#define HANDLE_NULL		(0)

/* nh^̒` */
typedef void*	HANDLE;




#endif	 /* __HOS__type_h__ */



/* end of file */
